	subroutine pftext( xc, yc, angle, size, font, text )
c
c Draw a character string.
c
c ( Inputs )
c  xc --- Center x coordinate of the first character.
c  yc --- Center y coordinate of the first character.
c  angle -- angle in degree.
c  size --- Character size in degree.
c  font --- 1 for simplex, 2 for duplex, 3 for UBC, 4 for gothic, 
c		5 for native, 0 for Greek.
c  text --- Text character string.
c
	implicit	none
c
	real*4		xc
	real*4		yc
	real*4		angle
	real*4		size
	integer*4	font
	character*(*)	text
c
c Local variables.
c
	real*4		ratio
	real*4		x
	real*4		y
	integer*4	i
	integer*4	bbit
	integer*4	nchar
	integer*4	status
	character*256	ptext
	character*256	stext
c
	logical*4	pftstdv
c
	common/ UGA013 / simplex_ptr
cmt4 	integer*2	simplex_ptr( 500 )
 	integer*4	simplex_ptr( 250 )
	common/ UGA014 / duplex_ptr
cmt4	integer*2	duplex_ptr( 500 )
	integer*4	duplex_ptr( 250 )
	common/ UGA015 / ubc_ptr
cmt4	integer*2	ubc_ptr( 500 )
	integer*4	ubc_ptr( 250 )
	common/ UGA016 / gothic_ptr
cmt4	integer*2	gothic_ptr( 500 )
	integer*4	gothic_ptr( 250 )
c
	nchar = len( text )
	call pfratio( ratio )
c
c Open the font data.
c
	if( font .eq. 0 ) then
	  call uge001( 0, 0, 0, 1, xc, yc, size, angle, ratio, 
	1					duplex_ptr, status )
	  do i = 1, nchar
	    stext( i:i ) = 'G'
	  enddo
	  call strupc( text, ptext )
	else if( font .eq. 4 ) then
	  call uge001( 0, 0, 0, 0, xc, yc, size, angle, ratio, 
	1					gothic_ptr, status )
	else if( font .eq. 3 ) then
	  call uge001( 0, 0, 0, 0, xc, yc, size, angle, ratio, 
	1					ubc_ptr, status )
	else if( font .eq. 2 ) then
	  call uge001( 0, 0, 0, 0, xc, yc, size, angle, ratio, 
	1					duplex_ptr, status )
	else if( font .eq. 5 ) then
c Device dependent font.
	  if( pftstdv( 'X' ) .or. pftstdv( 'ps' ) ) then
	    call pftextd( xc, yc, angle, size, text )
	    return
	  else
	    call uge001( 0, 0, 0, 0, xc, yc, size, angle, ratio, 
	1					simplex_ptr, status )
	  endif
	else
	  call uge001( 0, 0, 0, 0, xc, yc, size, angle, ratio, 
	1					simplex_ptr, status )
	endif
	if( status .eq. 1 ) then
	  print *, ' %ERROR in PFTEXT: Character table not found.'
	endif
c
c For PostScript, adjust the line width.
c
	call pfwidth( 1, size )
c
c Now loop over the characters in the string. Next calls of uge002 will
c convert the character to actual strokes.
c
100	continue
	  if( font .eq. 0 ) then
	    call uge002( ptext, stext, nchar, duplex_ptr, bbit, 
	1					x, y, status )
	  else if( font .eq. 4 ) then
	    call uge002( text, ' ', nchar, ubc_ptr, bbit, 
	1					x, y, status )
	  else if( font .eq. 3 ) then
	    call uge002( text, ' ', nchar, ubc_ptr, bbit, 
	1					x, y, status )
	  else if( font .eq. 2 ) then
	    call uge002( text, ' ', nchar, duplex_ptr, bbit, 
	1					x, y, status )
	  else
	    call uge002( text, ' ', nchar, simplex_ptr, bbit, 
	1					x, y, status )
	  endif
c
	  if( bbit .lt. 0 ) then
c end of the string.
	    go to 500
	  else if( bbit .eq. 0 ) then
c Dark vector.
	    call pfvect( x, y, 0 )
	  else
c Visible vector.
	    call pfvect( x, y, 1 )
	  endif
	go to 100
500	continue
	call pfwidth( 0, size )
	return
	end
