	subroutine pfvects( style, x, y, bbit )
c
c Move or draw a line segment with a specified texture.
c
c ( Inputs )
c  style --- 0: solid, 1: dashed, 2: dotted, 3: dotdash.
c  x, y -- coordinate
c  bbit -- 0: move, 1: draw.
c
	implicit	none
c
c Arguments.
	integer*4	style
	real*4		x, y
	integer*4	bbit
c
c Constant
	real*4		ADJUST
	parameter	( ADJUST = 0.05 )
	integer*4	MAX_DSP
	parameter	( MAX_DSP = 1000 )
c
c Locals
	real*4		window_scal( 4 )
	integer*4	dsp_scal( 4 )
	real*4		scrn_scal( 4 )
	integer*4	dsp_x, dsp_y
	real*4		wdw_x1, wdw_y1, wdw_x2, wdw_y2
	real*4		scrn_x1, scrn_y1, scrn_x2, scrn_y2
	real*4		scale
	real*4		xcmu, ycmu
	real*4		xc, yc
	integer*4	bbitx
c
c Now move/draw line.
	if( style .eq. 0 ) then
c Solid line.
	  call pfvect( x, y, bbit )
	else
c non soild line.
	  call pfgscal( window_scal, dsp_scal )
	  wdw_x1 = window_scal( 1 )
	  wdw_y1 = window_scal( 2 )
	  wdw_x2 = window_scal( 3 )
	  wdw_y2 = window_scal( 4 )
	  call pfgscrn( scrn_scal )
	  scrn_x1 = scrn_scal( 1 )
	  scrn_y1 = scrn_scal( 2 )
	  scrn_x2 = scrn_scal( 3 )
	  scrn_y2 = scrn_scal( 4 )
	  if( wdw_x2 .gt. wdw_x1 ) then
	    dsp_x = dsp_scal( 3 ) - dsp_scal( 1 )
	    scale = ( scrn_x2 - scrn_x1 ) / ( wdw_x2 - wdw_x1 )
	    xcmu = min0( dsp_x, MAX_DSP ) * ADJUST * scale
	  else
	    xcmu = 1.0
	  endif
	  if( wdw_y2 .gt. wdw_y1 ) then
	    dsp_y = dsp_scal( 4 ) - dsp_scal( 2 )
	    scale = ( scrn_y2 - scrn_y1 ) / ( wdw_y2 - wdw_y1 )
	    ycmu = min0( dsp_y, MAX_DSP ) * ADJUST * scale
	  else
	    ycmu = 1.0
	  endif
	  call ugd001( style, xcmu, ycmu )
	  if( bbit .eq. 0 ) then
	    call pfvect( x, y, 0 )
	    bbitx = 0
	    call ugd002( bbitx, x, y )
	    call ugd003( bbitx, xc, yc )
	  else if( bbit .eq. 1 ) then
	    bbitx = 1
	    call ugd002( bbitx, x, y )
	    do while( bbitx .ge. 0 )
	      call ugd003( bbitx, xc, yc )
	      if( bbitx .eq. 2 ) then
	        call pfine( xc, yc, xc, yc )
	      else
	        call pfvect( xc, yc, bbitx )
	      endif
	    enddo
	  endif
	endif
c
	return
	end
